


# Load firewall config
if [ -n "${main_cfg}" ]; then
	if [ ! -f "${main_cfg}" ]; then
		err_msg "\"${main_cfg}\" exist!"
		exit ${ER_NOEX}
	fi
else
	err_msg " file not specified"
	exit ${ER_NODEF}
fi

log -e "Checking for system files"
for file in "${PRO}" "${SER}" "${IP}"; do
	if [ ! -f ${file} ]; then
		log -x "${file}" ; return 1
	fi
done

nat_tc_mode_run() # OPEN and tc Mode only actions
{
handle_network_data || return ${?}
load_rules_conf || return ${ER_NOEX}
disable_rules
module_handling || return ${?}
compability_check || return ${?}
}

local qdev="dev ${OPTARG}"

if [ -z "${2}" ]; then reqparm ${FUNCNAME} 2; return 1; fi
local s_category=${1}
shift
local s_file=${*}
case "${s_category}" in
	script)	log -e "${pf} loading  ${s_file}" ;;
	rule)	log -R "\-\ Loading  ${s_file}" ;;
	config)	log -C "\-\ loading  ${s_file}" ;;
	*)	log -o "${s_category}" ; return 1 ;;
esac
[ -f "${s_file}" ] || { log -x "${s_file}" ; return 1; }
source "${s_file}" || { log -f "sourcing ${s_file}" ; return 1; }


[ ${VERBOSE} -ge 3 ] && echo "Loading ${main_cfg}"
source "${main_cfg}" || {
	err_msg "Failed loading \"${main_cfg}\""
	exit ${ER_LOAD}
}

if [ ${*} -lt 7 ]; then reqparm ${FUNCNAME} 7; fi
OPTIND=1 # reset index variable
while getopts d:p:o:r:h:m:i; do # enumerate options
	case "${option}" in
		d)	check_iface "${OPTARG}" || return 1
			local qdev="dev ${OPTARG}"
		;;
		p) 	val_numeric "${OPTARG/:/}" || return 1
			local qparent="parent ${OPTARG}"
		;;
		o) local qproto="protocol ${OPTARG}" ;;
		r) 	val_numeric "${OPTARG}" || return 1
			local qprio="prio ${OPTARG}"
		;;
		h) 	val_numeric "${OPTARG}" || return 1
			local qhandle="handle ${OPTARG}"
		;;
		m) local qdomain="${OPTARG}" ;;
		i) 	val_numeric "${OPTARG/:/}" || return 1
			local qclassid="classid ${OPTARG}"
		;;
		*) log -o "${option}" ${FUNCNAME} ; return 1 ;;
	esac
done
OPTIND=1 # reset index variable
add_tc_cmd "filter add  "

