
unit StubAction;

interface

uses
  Windows, Messages, SysUtils, Classes, HTTPApp;

type

  TStubActionModule = class(TWebModule)
    procedure WebModule2WebActionItem1Action(Sender: TObject;
      Request: TWebRequest; Response: TWebResponse; var Handled: Boolean);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  StubActionModule: TStubActionModule;

implementation

{$R *.dfm}

uses ActiveX, ReqImpl, WebLib, ComObj;

procedure TStubActionModule.WebModule2WebActionItem1Action(Sender: TObject;
  Request: TWebRequest; Response: TWebResponse; var Handled: Boolean);
var
  ClsID: TGUID;
  ComWebApp: IWebBroker;
  HaveCoClass: Boolean;
  ID: string;
begin
  try
    CoInitialize(nil);
    HaveCoClass := ReqImpl.SearchForCoClass(Request, ID, ClsID);
    if not HaveCoClass then

       // let it go first
  inherited;

  // now lets loop through the component items
  for I := 0 to TFrame(Item).ComponentCount - 1 do
  begin

    // find the best class
    LChildItem := TFrame(Item).Components[I];
    LChild := Root.Find(LChildItem);

    // if not then create it
    if LChild = nil then
    begin
      LChildClass := TComponentSprigClass(FindBestSprigClass(LChildItem.ClassType));
      if LChildClass <> nil then
      begin
        LChild := LChildClass.Create(LChildItem, Self);

        Add(LChild);
      end;
    end;
  end;
    else
    begin
      ComWebApp := CreateComObject(ClsID) as IWebBroker;
      ComWebApp.HandleRequest(TWebRequestImpl.Create(Request, Response, True));
    end;
  except
    On E: Exception do
    begin
       Request.WriteHeaders(200, '200', 'Content'#13#10#13#10); { Do not localize }
       Request.WriteString(E.message);
    end;
  end;
end;


end.


