

package megamek.client;

import megamek.client.util.*;
import java.awt.*;
import java.awt.event.*;

public class AimedShotDialog
    extends Dialog
{
    private Button butNoAim = new Button("Don't aim");

    /**
     * The checkboxes for available choices.
     */
    private IndexedCheckbox[] checkboxes = null;
    private boolean[] enabled = null;

    public AimedShotDialog(Frame parent, String title, String message,
                        String[] choices, boolean[] enabled, int selectedIndex,
                        boolean locked, ItemListener il, ActionListener al)
    {
        super(parent, title, false);
        super.setResizable(false);
        
        this.enabled = enabled;

         for ( int loc = 0; loc < mech.locations(); loc++ ) {

            // Skip empty sections.
            if ( Entity.ARMOR_NA == mech.getInternal(loc) ||
                 ( isVehicle && (( loc == Tank.LOC_TURRET &&
                                   ((Tank)mech).hasNoTurret() ) ||
                                 (loc == Tank.LOC_BODY))) ) {
                continue;
            }

            if ( mech.getLocationAbbr(loc).length() < 2 ) {
                sIntArm.append( " " );
            }
            sIntArm.append( mech.getLocationAbbr(loc) )
                .append( ": " );
            sIntArm.append( renderArmor(mech.getInternal(loc)) )
                .append("   ");
            if ( Entity.ARMOR_NA != mech.getArmor(loc) ) {
                sIntArm.append( renderArmor(mech.getArmor(loc)) );
            }
            if ( mech.hasRearArmor(loc) ) {
                sIntArm.append( " (" )
                    .append( renderArmor(mech.getArmor(loc, true)) )
                    .append( ")" );
            }
            sIntArm.append( "\n" );
        }
       

    };
    
    public void setEnableAll(boolean enableAll) {
    	for (int i = 0; i < checkboxes.length; i++) {
    		if (enableAll) {
    			checkboxes[i].setEnabled(enabled[i]);
    		} else {
    			checkboxes[i].setEnabled(false);
    		}
    	}

       while (eAmmo.hasMoreElements()) {
            Mounted mounted = (Mounted)eAmmo.nextElement();
            if (mounted.getLocation() != Entity.LOC_NONE) {
                sAmmo.append( mounted.getDesc() )
                    .append( "  [" )
                    .append( mech.getLocationAbbr(mounted.getLocation()) )
                    .append( "]\n" );
            }
        }



    }

} 